/////////////////////////
// C++ DLL			   //
// By Nicholas Skapura //
// 17 February 2002	   //
/////////////////////////


////////// Header Files //////////
#include <windows.h>
#include <string.h>
#include "dllutil.h"


// Structure for the struc argument example.
struct testStruct
{
	
	short shortVar;
	unsigned char ucharVar;
	float floatVar;
	BSTR stringVar;
};


////////// Global Variables //////////
char module[50];
short initVar = 0;


// Simple Sub Call
void __declspec(dllexport) CALLBACK TestSub()
{
	GetModuleFileName(NULL,(LPTSTR)module,50);
	::MessageBox(NULL,module,"Location of the client",0);
}


// Receives a value and returns one.
short __declspec(dllexport) CALLBACK SimpleFunc(short value)
{
	return value * initVar;
}

// Receives a value and returns one through an argument.
void __declspec(dllexport) CALLBACK FuncByRef(short value,short *returnVar)
{
	*returnVar = value * initVar;
}

// Receives a structure and alters it.
void __declspec(dllexport) CALLBACK StructExample(testStruct *data)
{
	data->shortVar = 1;
	data->ucharVar = 'b';
	data->floatVar = (float)3.4;
}

// Receives a currency argument and returns one.
__int64 __declspec(dllexport) CALLBACK CurrencyExample(__int64 c1,__int64 c2)
{
	return(c1 + c2);
}

// Receives a string argument and returns one.
BSTR __declspec(dllexport) CALLBACK StringExample(BSTR stringVar)
{
	LPSTR buffer;
	buffer = (LPSTR)stringVar; // The address is coerced into an LPSTR.
	::MessageBox(NULL,buffer,"in C++",0);
	buffer = _strrev(buffer);
	return(SysAllocString(stringVar)); // Since buffer has the address, the argument
									   // can still be returned.
}

// Receives an array and returns one of its elements.
BSTR __declspec(dllexport) CALLBACK ArrayExample(LPSAFEARRAY FAR *data,short index)
{
	BSTR *tempArray;
	index--;			// Arrays begin at zero in C/C++ and at one in Visual Basic.
	tempArray = (BSTR*)(*data)->pvData;
	return(SysAllocString(tempArray[index]));
}

// Receives the address of a Visual Basic function and calls it.
void __declspec(dllexport) CALLBACK CallbackExample(long Addr1)
{
	typedef void (__stdcall *FNPTR)(BSTR stringVar);
	FNPTR FunctionCall;
	FunctionCall = (FNPTR)Addr1;
	BSTR temp = ChartoBSTR("hello");
	FunctionCall(SysAllocString(temp));
}

// Called during certain system events.
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch(ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		::MessageBox(NULL,"Initializing the DLL.","C++ DLL",0);
		break;
	case DLL_PROCESS_DETACH:
		::MessageBox(NULL,"Closing down the DLL.","C++ DLL",0);
		break;
	}
	initVar = 10;
    return TRUE;
}